diff --git a/CMakeLists.txt b/CMakeLists.txt
index b1ad102b4..52436e3ce 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -267,6 +267,10 @@ if(CMAKE_COMPILER_IS_GNUCC)
 				set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
 			endif()
 		endif()
+		if(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64")
+				set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mcpu=cortex-a35")
+		endif()		
+
 	endif()
 
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
diff --git a/libfreerdp/codec/rfx_neon.c b/libfreerdp/codec/rfx_neon.c
index c41ebb404..6e6de4bed 100644
--- a/libfreerdp/codec/rfx_neon.c
+++ b/libfreerdp/codec/rfx_neon.c
@@ -32,6 +32,7 @@
 #include "rfx_types.h"
 #include "rfx_neon.h"
 
+#include "sse2neon.h"
 /* rfx_decode_YCbCr_to_RGB_NEON code now resides in the primitives library. */
 
 static __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
@@ -227,9 +228,183 @@ static void rfx_dwt_2d_decode_NEON(INT16* buffer, INT16* dwt_buffer)
 	rfx_dwt_2d_decode_block_NEON(buffer, dwt_buffer, 32);
 }
 
+
+
+static __inline void __attribute__((ATTRIBUTES))
+rfx_dwt_2d_encode_block_vert_sse2(INT16* src, INT16* l, INT16* h, int subband_width)
+{
+	int total_width;
+	int x;
+	int n;
+	__m128i src_2n;
+	__m128i src_2n_1;
+	__m128i src_2n_2;
+	__m128i h_n;
+	__m128i h_n_m;
+	__m128i l_n;
+	total_width = subband_width << 1;
+
+	for (n = 0; n < subband_width; n++)
+	{
+		for (x = 0; x < total_width; x += 8)
+		{
+			src_2n = _mm_load_si128((__m128i*)src);
+			src_2n_1 = _mm_load_si128((__m128i*)(src + total_width));
+
+			if (n < subband_width - 1)
+				src_2n_2 = _mm_load_si128((__m128i*)(src + 2 * total_width));
+			else
+				src_2n_2 = src_2n;
+
+			/* h[n] = (src[2n + 1] - ((src[2n] + src[2n + 2]) >> 1)) >> 1 */
+			h_n = _mm_add_epi16(src_2n, src_2n_2);
+			h_n = _mm_srai_epi16(h_n, 1);
+			h_n = _mm_sub_epi16(src_2n_1, h_n);
+			h_n = _mm_srai_epi16(h_n, 1);
+			_mm_store_si128((__m128i*)h, h_n);
+
+			if (n == 0)
+				h_n_m = h_n;
+			else
+				h_n_m = _mm_load_si128((__m128i*)(h - total_width));
+
+			/* l[n] = src[2n] + ((h[n - 1] + h[n]) >> 1) */
+			l_n = _mm_add_epi16(h_n_m, h_n);
+			l_n = _mm_srai_epi16(l_n, 1);
+			l_n = _mm_add_epi16(l_n, src_2n);
+			_mm_store_si128((__m128i*)l, l_n);
+			src += 8;
+			l += 8;
+			h += 8;
+		}
+
+		src += total_width;
+	}
+}
+
+static __inline void __attribute__((ATTRIBUTES))
+rfx_dwt_2d_encode_block_horiz_sse2(INT16* src, INT16* l, INT16* h, int subband_width)
+{
+	int y;
+	int n;
+	int first;
+	__m128i src_2n;
+	__m128i src_2n_1;
+	__m128i src_2n_2;
+	__m128i h_n;
+	__m128i h_n_m;
+	__m128i l_n;
+
+	for (y = 0; y < subband_width; y++)
+	{
+		for (n = 0; n < subband_width; n += 8)
+		{
+			/* The following 3 Set operations consumes more than half of the total DWT processing
+			 * time! */
+			src_2n =
+			    _mm_set_epi16(src[14], src[12], src[10], src[8], src[6], src[4], src[2], src[0]);
+			src_2n_1 =
+			    _mm_set_epi16(src[15], src[13], src[11], src[9], src[7], src[5], src[3], src[1]);
+			src_2n_2 = _mm_set_epi16(n == subband_width - 8 ? src[14] : src[16], src[14], src[12],
+			                         src[10], src[8], src[6], src[4], src[2]);
+			/* h[n] = (src[2n + 1] - ((src[2n] + src[2n + 2]) >> 1)) >> 1 */
+			h_n = _mm_add_epi16(src_2n, src_2n_2);
+			h_n = _mm_srai_epi16(h_n, 1);
+			h_n = _mm_sub_epi16(src_2n_1, h_n);
+			h_n = _mm_srai_epi16(h_n, 1);
+			_mm_store_si128((__m128i*)h, h_n);
+			h_n_m = _mm_loadu_si128((__m128i*)(h - 1));
+
+			if (n == 0)
+			{
+				first = _mm_extract_epi16(h_n_m, 1);
+				h_n_m = _mm_insert_epi16(h_n_m, first, 0);
+			}
+
+			/* l[n] = src[2n] + ((h[n - 1] + h[n]) >> 1) */
+			l_n = _mm_add_epi16(h_n_m, h_n);
+			l_n = _mm_srai_epi16(l_n, 1);
+			l_n = _mm_add_epi16(l_n, src_2n);
+			_mm_store_si128((__m128i*)l, l_n);
+			src += 16;
+			l += 8;
+			h += 8;
+		}
+	}
+}
+
+static __inline void __attribute__((ATTRIBUTES))
+rfx_dwt_2d_encode_block_sse2(INT16* buffer, INT16* dwt, int subband_width)
+{
+	INT16 *hl, *lh, *hh, *ll;
+	INT16 *l_src, *h_src;
+//	_mm_prefetch_buffer((char*)dwt, subband_width * 4 * sizeof(INT16));
+	/* DWT in vertical direction, results in 2 sub-bands in L, H order in tmp buffer dwt. */
+	l_src = dwt;
+	h_src = dwt + subband_width * subband_width * 2;
+	rfx_dwt_2d_encode_block_vert_sse2(buffer, l_src, h_src, subband_width);
+	/* DWT in horizontal direction, results in 4 sub-bands in HL(0), LH(1), HH(2), LL(3) order,
+	 * stored in original buffer. */
+	/* The lower part L generates LL(3) and HL(0). */
+	/* The higher part H generates LH(1) and HH(2). */
+	ll = buffer + subband_width * subband_width * 3;
+	hl = buffer;
+	lh = buffer + subband_width * subband_width;
+	hh = buffer + subband_width * subband_width * 2;
+	rfx_dwt_2d_encode_block_horiz_sse2(l_src, ll, hl, subband_width);
+	rfx_dwt_2d_encode_block_horiz_sse2(h_src, lh, hh, subband_width);
+}
+
+static void rfx_dwt_2d_encode_sse2(INT16* buffer, INT16* dwt_buffer)
+{
+//	_mm_prefetch_buffer((char*)buffer, 4096 * sizeof(INT16));
+	rfx_dwt_2d_encode_block_sse2(buffer, dwt_buffer, 32);
+	rfx_dwt_2d_encode_block_sse2(buffer + 3072, dwt_buffer, 16);
+	rfx_dwt_2d_encode_block_sse2(buffer + 3840, dwt_buffer, 8);
+}
+
+
+static __inline void __attribute__((ATTRIBUTES))
+rfx_quantization_encode_block_sse2(INT16* buffer, const int buffer_size, const UINT32 factor)
+{
+	__m128i a;
+	__m128i* ptr = (__m128i*)buffer;
+	__m128i* buf_end = (__m128i*)(buffer + buffer_size);
+	__m128i half;
+
+	if (factor == 0)
+		return;
+
+	half = _mm_set1_epi16(1 << (factor - 1));
+
+	do
+	{
+		a = _mm_load_si128(ptr);
+		a = _mm_add_epi16(a, half);
+		a = _mm_srai_epi16(a, factor);
+		_mm_store_si128(ptr, a);
+		ptr++;
+	} while (ptr < buf_end);
+}
+
+static void rfx_quantization_encode_sse2(INT16* buffer, const UINT32* quantization_values)
+{
+	rfx_quantization_encode_block_sse2(buffer, 1024, quantization_values[8] - 6);        /* HL1 */
+	rfx_quantization_encode_block_sse2(buffer + 1024, 1024, quantization_values[7] - 6); /* LH1 */
+	rfx_quantization_encode_block_sse2(buffer + 2048, 1024, quantization_values[9] - 6); /* HH1 */
+	rfx_quantization_encode_block_sse2(buffer + 3072, 256, quantization_values[5] - 6);  /* HL2 */
+	rfx_quantization_encode_block_sse2(buffer + 3328, 256, quantization_values[4] - 6);  /* LH2 */
+	rfx_quantization_encode_block_sse2(buffer + 3584, 256, quantization_values[6] - 6);  /* HH2 */
+	rfx_quantization_encode_block_sse2(buffer + 3840, 64, quantization_values[2] - 6);   /* HL3 */
+	rfx_quantization_encode_block_sse2(buffer + 3904, 64, quantization_values[1] - 6);   /* LH3 */
+	rfx_quantization_encode_block_sse2(buffer + 3968, 64, quantization_values[3] - 6);   /* HH3 */
+	rfx_quantization_encode_block_sse2(buffer + 4032, 64, quantization_values[0] - 6);   /* LL3 */
+	rfx_quantization_encode_block_sse2(buffer, 4096, 5);
+}
+
 void rfx_init_neon(RFX_CONTEXT* context)
 {
-	if (IsProcessorFeaturePresent(PF_ARM_NEON_INSTRUCTIONS_AVAILABLE))
+	//if (IsProcessorFeaturePresent(PF_ARM_NEON_INSTRUCTIONS_AVAILABLE))
 	{
 		DEBUG_RFX("Using NEON optimizations");
 		PROFILER_RENAME(context->priv->prof_rfx_ycbcr_to_rgb, "rfx_decode_YCbCr_to_RGB_NEON");
@@ -238,6 +413,8 @@ void rfx_init_neon(RFX_CONTEXT* context)
 		PROFILER_RENAME(context->priv->prof_rfx_dwt_2d_decode, "rfx_dwt_2d_decode_NEON");
 		context->quantization_decode = rfx_quantization_decode_NEON;
 		context->dwt_2d_decode = rfx_dwt_2d_decode_NEON;
+		context->dwt_2d_encode = rfx_dwt_2d_encode_sse2;
+		context->quantization_encode = rfx_quantization_encode_sse2;
 	}
 }
 
diff --git a/libfreerdp/primitives/prim_colors.c b/libfreerdp/primitives/prim_colors.c
index ac9456f35..75b12f465 100644
--- a/libfreerdp/primitives/prim_colors.c
+++ b/libfreerdp/primitives/prim_colors.c
@@ -24,6 +24,7 @@
 #include <freerdp/types.h>
 #include <freerdp/primitives.h>
 #include <freerdp/codec/color.h>
+#include <arm_neon.h>
 
 #include "prim_internal.h"
 
@@ -212,6 +213,93 @@ static pstatus_t general_yCbCrToRGB_16s16s_P3P3(const INT16* const pSrc[3], INT3
 }
 
 /* ------------------------------------------------------------------------- */
+
+static pstatus_t NEON_RGBToYCbCr_16s16s_P3P3(const INT16* const pSrc[3], INT32 srcStep,
+                                                INT16* pDst[3], INT32 dstStep,
+                                                const prim_size_t* roi) 
+{
+	const INT16* rptr = pSrc[0];
+	const INT16* gptr = pSrc[1];
+	const INT16* bptr = pSrc[2];
+	INT16* yptr = pDst[0];
+	INT16* cbptr = pDst[1];
+	INT16* crptr = pDst[2];
+	
+	UINT32 srcbump = (srcStep - (roi->width * sizeof(UINT16))) / sizeof(UINT16);
+	UINT32 dstbump = (dstStep - (roi->width * sizeof(UINT16))) / sizeof(UINT16);
+	UINT32 y_LINE, x;
+
+	const int32x4_t y_9798 = vdupq_n_s32(9798);
+        const int32x4_t y_19235 = vdupq_n_s32(19235);
+        const int32x4_t y_3735 = vdupq_n_s32(3735);
+        const int32x4_t cb_5535 = vdupq_n_s32(-5535);
+        const int32x4_t cb_10868 = vdupq_n_s32(-10868);
+        const int32x4_t cb_16403 = vdupq_n_s32(16403);
+        const int32x4_t cr_16377 = vdupq_n_s32(16377);
+        const int32x4_t cr_13714 = vdupq_n_s32(-13714);
+        const int32x4_t cr_2663 = vdupq_n_s32(-2663);
+        const int32x4_t con_min = vdupq_n_s32(-4096);
+        const int32x4_t con_max = vdupq_n_s32(4095);
+
+        int16x4_t v_16_r, v_16_g,  v_16_b;
+        int32x4_t v_32_r, v_32_g, v_32_b;
+        int32x4_t tmp0, tmp1;
+
+	for (y_LINE = 0; y_LINE < roi->height; y_LINE++)
+	{
+		for (x = 0; x <  roi->width/4; ++x)
+		{
+			v_16_r = vld1_s16(rptr);
+			v_16_g = vld1_s16(gptr);
+			v_16_b = vld1_s16(bptr);
+			v_32_r = vmovl_s16(v_16_r);
+			v_32_g = vmovl_s16(v_16_g);
+			v_32_b = vmovl_s16(v_16_b);
+
+			tmp0 = vmulq_s32(v_32_r, y_9798);
+			tmp1 = vmulq_s32(v_32_g, y_19235);
+			tmp0 = vmlaq_s32(tmp0, v_32_b, y_3735);
+			tmp0 = vaddq_s32(tmp0, tmp1);
+			tmp0 = vshrq_n_s32(tmp0, 10);
+			tmp0 = vaddq_s32(tmp0, con_min);
+			tmp0 = vminq_s32(con_max, vmaxq_s32(tmp0, con_min));
+			vst1_s16(yptr, vmovn_s32(tmp0));
+
+			tmp0 = vmulq_s32(v_32_r, cb_5535);
+			tmp1 = vmulq_s32(v_32_b, cb_16403);
+			tmp0 = vmlaq_s32(tmp0, v_32_g, cb_10868);
+			tmp0 = vaddq_s32(tmp0, tmp1);
+			tmp0 = vshrq_n_s32(tmp0, 10);
+			tmp0 = vminq_s32(con_max, vmaxq_s32(tmp0, con_min));
+			vst1_s16(cbptr, vmovn_s32(tmp0));
+
+			tmp0 = vmulq_s32(v_32_r, cr_16377);
+			tmp1 = vmulq_s32(v_32_b, cr_2663);
+			tmp0 = vmlaq_s32(tmp0, v_32_g, cr_13714);
+			tmp0 =  vaddq_s32(tmp1, tmp0);
+			tmp0 = vshrq_n_s32(tmp0, 10);
+			tmp0 = vminq_s32(con_max, vmaxq_s32(tmp0, con_min));
+			vst1_s16(crptr, vmovn_s32(tmp0));
+
+			rptr = rptr + 4;	
+			gptr = gptr + 4;
+			bptr = bptr + 4;
+			yptr = yptr + 4;
+			cbptr = cbptr + 4;
+			crptr = crptr + 4;	
+		}
+
+		yptr += srcbump;
+		cbptr += srcbump;
+		crptr += srcbump;
+		rptr += dstbump;
+		gptr += dstbump;
+		bptr += dstbump;
+	}
+
+	return PRIMITIVES_SUCCESS;
+}
+
 static pstatus_t general_RGBToYCbCr_16s16s_P3P3(const INT16* const pSrc[3], INT32 srcStep,
                                                 INT16* pDst[3], INT32 dstStep,
                                                 const prim_size_t* roi) /* region of interest */
@@ -514,6 +602,6 @@ void primitives_init_colors(primitives_t* prims)
 {
 	prims->yCbCrToRGB_16s8u_P3AC4R = general_yCbCrToRGB_16s8u_P3AC4R;
 	prims->yCbCrToRGB_16s16s_P3P3 = general_yCbCrToRGB_16s16s_P3P3;
-	prims->RGBToYCbCr_16s16s_P3P3 = general_RGBToYCbCr_16s16s_P3P3;
+	prims->RGBToYCbCr_16s16s_P3P3 = NEON_RGBToYCbCr_16s16s_P3P3; //general_RGBToYCbCr_16s16s_P3P3;
 	prims->RGBToRGB_16s8u_P3AC4R = general_RGBToRGB_16s8u_P3AC4R;
 }
